CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  _stack = ($3000 + $3000 + 100) >> 2   'accomodate display memory and stack

  x_tiles = 16
  y_tiles = 12

  paramcount = 14       
  bitmap_base = $2000
  display_base = $5000

  screen_height=192
  screen_width=256

  x0=0
  y0=0

  height=96
  width=128
  
VAR

  long  tv_status     '0/1/2 = off/visible/invisible           read-only
  long  tv_enable     '0/? = off/on                            write-only
  long  tv_pins       '%ppmmm = pins                           write-only
  long  tv_mode       '%ccinp = chroma,interlace,ntsc/pal,swap write-only
  long  tv_screen     'pointer to screen (words)               write-only
  long  tv_colors     'pointer to colors (longs)               write-only               
  long  tv_hc         'horizontal cells                        write-only
  long  tv_vc         'vertical cells                          write-only
  long  tv_hx         'horizontal cell expansion               write-only
  long  tv_vx         'vertical cell expansion                 write-only
  long  tv_ho         'horizontal offset                       write-only
  long  tv_vo         'vertical offset                         write-only
  long  tv_broadcast  'broadcast frequency (Hz)                write-only
  long  tv_auralcog   'aural fm cog                            write-only

  word  screen[x_tiles * y_tiles]
  long  colors[64]

  byte xloc,yloc

  long color


OBJ
  hss  : "yma_hss_v1.2"
  tv    : "tv"
  gr    : "graphics"
   

PUB start|i,j

  'start tv
  longmove(@tv_status, @tvparams, paramcount)
  tv_screen := @screen
  tv_colors := @colors
  tv.start(@tv_status)

  'hss.start

  repeat
   repeat i from 1 to 4 
    drawBox(i)
    waitcnt(20_000_000+cnt)
  
PUB drawBox(position)|mult,i,dx,dy

      boxPosition(position)
      
      mult:=color
      mult*=$10101010
      repeat i from 0 to 63
        colors[i]:= $1f_1f_1f_11  | mult
      
      'init tile screen
      repeat dx from 0 to tv_hc - 1
        repeat dy from 0 to tv_vc - 1
          screen[dy * tv_hc + dx] := display_base >> 6 + dy + dx * tv_vc + ((dy & $3F) << 10)      
       
      'start and setup graphics
      gr.start
      gr.setup(x_tiles, y_tiles, x0, y0, bitmap_base)

      'clear bitmap
      gr.clear 
      gr.box(xloc,yloc,width,height)
      'copy bitmap to display
      gr.copy(display_base)

PUB boxPosition(number)

    case number
      1:
        xloc:=0
        yloc:=screen_height-height
        color:=color_list[0]
        'want sound selection to be here
        
      2:
        xloc:=screen_width-width
        yloc:=screen_height-height
        color:=color_list[3]
        'want sound selection to be here 
      3:
        xloc:=0
        yloc:=0
        color:=color_list[5]
        'want sound selection to be here 
      4:
        xloc:=screen_width-width
        yloc:=0
        color:=color_list[1]
        'want sound selection to be here 
DAT

tvparams                long    0               'status
                        long    1               'enable
                        long    %001_0101       'pins
                        long    %0000           'mode
                        long    0               'screen
                        long    0               'colors
                        long    x_tiles         'hc
                        long    y_tiles         'vc
                        long    10              'hx
                        long    1               'vx
                        long    0               'ho
                        long    0               'vo
                        long    0               'broadcast
                        long    0               'auralcog

color_list              byte    1               'orange
                        byte    2               'red
                        byte    4               'purple
                        byte    8               'blue
                        byte    10              'light blue
                        byte    12              'green


SoundFX1                byte    $0f, $ff, $80, $0F, $0F, $00, $07, $90  
                                'Att 'Dec 'Sus 'Rel
                        byte    $FF, $10, $00, $FF

                                'Wav 'Len 'Fre 'Vol 'LFO 'LFW 'FMa 'AMa
SoundFX2                byte    $05, $FF, $00, $0F, $04, $FF, $01, $05
                                'Att 'Dec 'Sus 'Rel
                        byte    $F1, $24, $00, $FF
                        
SoundFX3                byte    $0f, $ff, $80, $0F, $0F, $00, $07, $90  
                                'Att 'Dec 'Sus 'Rel
                        byte    $FF, $10, $00, $FF

                                'Wav 'Len 'Fre 'Vol 'LFO 'LFW 'FMa 'AMa
SoundFX4                byte    $05, $FF, $00, $0F, $04, $FF, $01, $05
                                'Att 'Dec 'Sus 'Rel
                        byte    $F1, $24, $00, $FF  